#!/bin/bash
set -ex

# see man flock "EXAMPLES"
[ "${FLOCKER}" != "$0" ] && exec env FLOCKER="$0" flock -enF "$0" "$0" "$@" || :

RT="{{ metws_job_scripts }}/util/rounded_times"

MINLAT="{{ eumetsat_geotiff_minlat }}"
MINLON="{{ eumetsat_geotiff_minlon }}"
MAXLAT="{{ eumetsat_geotiff_maxlat }}"
MAXLON="{{ eumetsat_geotiff_maxlon }}"
WIDTH="{{ eumetsat_geotiff_width }}"
HEIGHT="{{ eumetsat_geotiff_height }}"

DATADIR="{{ eumetsat_geotiff_dataroot }}"
WORKDIR="{{ eumetsat_geotiff_workroot }}"
mkdir -p "$WORKDIR" "$DATADIR"

get_one_image() {
    LAYER="$1"
    DATE="$2"
    FILE="$3"

    FORMAT="image/png"
    STYLE="&STYLES=raster"

    TIME="&TIME=${DATE}"
    URL="https://view.eumetsat.int/geoserver/wms?SERVICE=WMS&REQUEST=GetMap&TRANSPARENT=TRUE&EXCEPTIONS=XML&VERSION=1.3.0&LAYERS=${LAYER}${STYLE}&SRS=EPSG:4326&WIDTH=${WIDTH}&HEIGHT=${HEIGHT}&BBOX=$MINLAT,$MINLON,$MAXLAT,$MAXLON&FORMAT=${FORMAT}${TIME}"

    wms_file="$WORKDIR/wms-$FILE.png"
    tiff_file="$DATADIR/$FILE.tif"

    if test ! -r "$wms_file" ; then
        curl -s -o "$wms_file" "$URL" \
            || rm -vf "$wms_file"
    fi
    if test "$wms_file" -a ! -r "$tiff_file" ; then
        gdal_translate -q \
                       -a_srs '+proj=longlat +ellps=WGS84 +datum=WGS84' \
                       -a_ullr "$MINLON" "$MAXLAT" "$MAXLON" "$MINLAT" \
                       -co COMPRESS=DEFLATE \
                       "$wms_file" \
                       "$tiff_file" \
            || rm -vf "tiff_file"
    fi
}

# cleanup
AGE=10
find "$DATADIR" -name '*.tif' -mtime "+$AGE" -exec rm -vf \{\} \;
find "$WORKDIR" -name '*.png' -mtime "+$AGE" -exec rm -vf \{\} \;

# get new
{% for l in eumetsat_geotiff_layers %}
TIFF_FILES=()
for t in `$RT --interval={{ l.interval }} --count={{ l.count }} --skip={{ l.skip }}` ; do
    YMD=`date --utc '+%Y%m%d%H%M' --date "$t"`
    f="eumetsat-{{ l.filename }}-$YMD"
    get_one_image "{{ l.name }}" "$t" "$f"
    TIFF_FILES+=("$DATADIR/$f.tif")
done
MP={{ metws_job_scripts | quote }}/util/make_time_size_prom_file
if test -x "$MP" ; then
    "$MP" devcoop_eumetsat_geotiff_latest "eumetsat geotiff" --file "devcoop_eumetsat_geotiff_latest_{{ l.filename }}" --labels '{name="{{ l.name }}"}' "${TIFF_FILES[@]}"
fi

{% endfor %}
